models/ContactForm.php
<?php

namespace app\models;

use Yii;
use yii\base\Model;

/**
 * ContactForm is the model behind the contact form.
 */
class ContactForm extends Model
{
    public $name;
    public $email;
    public $subject;
    public $body;
    public $verifyCode;


    /**
     * @return array the validation rules.
     */
    public function rules()
    {
        return [
            // name, email, subject and body are required
            [['name', 'email', 'subject', 'body'], 'required'],
            // email has to be a valid email address
            ['email', 'email'],
            // verifyCode needs to be entered correctly
            ['verifyCode', 'captcha'],
        ];
    }

    /**
     * @return array customized attribute labels
     */
    public function attributeLabels()
    {
        return [
            'verifyCode' => 'Verification Code',
        ];
    }

    /**
     * Sends an email to the specified email address using the information collected by this model.
     * @param string $email the target email address
     * @return bool whether the model passes validation
     */
    public function contact($email)
    {
        if ($this->validate()) {
            Yii::$app->mailer->compose()
                ->setTo($email)
                ->setFrom([$this->email => $this->name])
                ->setSubject($this->subject)
                ->setTextBody($this->body)
                ->send();

            return true;
        }
        return false;
    }
}

models/LoginForm.php
<?php

namespace app\models;

use Yii;
use yii\base\Model;

/**
 * LoginForm is the model behind the login form.
 *
 * @property User|null $user This property is read-only.
 *
 */
class LoginForm extends Model
{
    public $username;
    public $password;
    public $rememberMe = true;

    private $_user = false;


    /**
     * @return array the validation rules.
     */
    public function rules()
    {
        return [
            // username and password are both required
            [['username', 'password'], 'required'],
            // rememberMe must be a boolean value
            ['rememberMe', 'boolean'],
            // password is validated by validatePassword()
            ['password', 'validatePassword'],
        ];
    }

    /**
     * Validates the password.
     * This method serves as the inline validation for password.
     *
     * @param string $attribute the attribute currently being validated
     * @param array $params the additional name-value pairs given in the rule
     */
    public function validatePassword($attribute, $params)
    {
        if (!$this->hasErrors()) {
            $user = $this->getUser();

            if (!$user || !$user->validatePassword($this->password)) {
                $this->addError($attribute, 'Incorrect username or password.');
            }
        }
    }

    /**
     * Logs in a user using the provided username and password.
     * @return bool whether the user is logged in successfully
     */
    public function login()
    {
        if ($this->validate()) {
            return Yii::$app->user->login($this->getUser(), $this->rememberMe ? 3600*24*30 : 0);
        }
        return false;
    }

    /**
     * Finds user by [[username]]
     *
     * @return User|null
     */
    public function getUser()
    {
        if ($this->_user === false) {
            $this->_user = User::findByUsername($this->username);
        }

        return $this->_user;
    }
}

models/User.php
<?php

namespace app\models;

class User extends \yii\base\BaseObject implements \yii\web\IdentityInterface
{
    public $id;
    public $username;
    public $password;
    public $authKey;
    public $accessToken;

    private static $users = [
        '100' => [
            'id' => '100',
            'username' => 'admin',
            'password' => 'admin',
            'authKey' => 'test100key',
            'accessToken' => '100-token',
        ],
        '101' => [
            'id' => '101',
            'username' => 'demo',
            'password' => 'demo',
            'authKey' => 'test101key',
            'accessToken' => '101-token',
        ],
    ];


    /**
     * {@inheritdoc}
     */
    public static function findIdentity($id)
    {
        return isset(self::$users[$id]) ? new static(self::$users[$id]) : null;
    }

    /**
     * {@inheritdoc}
     */
    public static function findIdentityByAccessToken($token, $type = null)
    {
        foreach (self::$users as $user) {
            if ($user['accessToken'] === $token) {
                return new static($user);
            }
        }

        return null;
    }

    /**
     * Finds user by username
     *
     * @param string $username
     * @return static|null
     */
    public static function findByUsername($username)
    {
        foreach (self::$users as $user) {
            if (strcasecmp($user['username'], $username) === 0) {
                return new static($user);
            }
        }

        return null;
    }

    /**
     * {@inheritdoc}
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * {@inheritdoc}
     */
    public function getAuthKey()
    {
        return $this->authKey;
    }

    /**
     * {@inheritdoc}
     */
    public function validateAuthKey($authKey)
    {
        return $this->authKey === $authKey;
    }

    /**
     * Validates password
     *
     * @param string $password password to validate
     * @return bool if password provided is valid for current user
     */
    public function validatePassword($password)
    {
        return $this->password === $password;
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;

class SiteController extends Controller{

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex(){
        return $this->render('index');
    }

    public function actionEstamos(){
        return $this->render('estamos');
    }
    
    public function actionConocenos(){
        return $this->render('conocenos');
    }
    
    public function actionOperaciones(){
        return $this->render('operaciones');
    }
    
    /* acción por defecto de Yii 2
    
    public function actionContacto(){
        // var_dump(Yii::$app->request->get('nombre')); sólo el campo nombre
        // var_dump(Yii::$app->request->get()); todo el array
        Yii::$app->request->get();
        return $this->render('contacto',[
            'titulo' => 'Introduce tus datos',
        ]);
    }
    
     */
    
    public function actionContacto(){
        
       //var_dump(Yii::$app->request->get('nombre'));
        //var_dump($_REQUEST);
        $longitud=0;
        $datos=Yii::$app->request->get();
        $vista="contacto";
        //var_dump($datos);
        
        /**
         * conocer si he pulsado el boton de enviar y por lo tanto
         * me llegan datos
         */
        if(isset($datos['boton'])){
            $longitud=strlen($datos['nombre']);
            $vista="resultado";
            //var_dump($longitud);
        }
               
        return $this->render($vista,[
           'titulo'=>'Introduce tus datos',
            'longitud'=>$longitud,
        ]);
    }
    
    public function actionContacto1(){
        // var_dump(Yii::$app->request->get('nombre')); sólo el campo nombre
        // var_dump(Yii::$app->request->get()); todo el array
        $longitud=0;
        $datos=Yii::$app->request->get();
        
        // var_dump($datos);
        
        // Comprobar si se ha pulsado el botón y me llegan datos
        if(isset($datos['boton'])){
            $longitud=strlen($datos['nombre']);
        
            return $this->render('contacto',[
                'longitud' => $longitud,
            ]);
        }
        return $this->render('contacto',[
                'titulo' => 'Introduce tus datos',
        ]);
    }

}


/* Cambiar siempre la vista de url en config/web.php - Descomentar línea 47 a 52 y cambiar a true

'urlManager' => [
            'enablePrettyUrl' => true,
            'showScriptName' => true,
            'rules' => [
            ],
        ],

 */

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\widgets\Alert;
use yii\helpers\Html;
use yii\bootstrap\Nav;
use yii\bootstrap\NavBar;
use yii\widgets\Breadcrumbs;
use app\assets\AppAsset;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <?= Html::csrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body>
<?php $this->beginBody() ?>

<div class="wrap">
    
    <?php
        NavBar::begin([
            'brandLabel' => Yii::$app->name,
            'brandUrl' => Yii::$app->homeUrl,
            'options' => ['class' => 'navbar navbar-default'],
            ]);
            echo Nav::widget([
                'options' => ['class' => 'navbar-nav navbar-right'],
                'items' => [
                    ['label' => 'Home', 'url' => ['/site/index']],
                    ['label' => 'About', 'url' => ['/site/about']],
                    ['label' => 'Contact', 'url' => ['/site/contact']],
                    Yii::$app->user->isGuest ? (
                        ['label' => 'Login', 'url' => ['/site/login']]
                    ) : (
                        '<li>'
                        . Html::beginForm(['/site/logout'], 'post')
                        . Html::submitButton(
                            'Logout (' . Yii::$app->user->identity->username . ')',
                            ['class' => 'btn btn-link logout']
                        )
                        . Html::endForm()
                        . '</li>'
                    )
                ],
            ]);
        NavBar::end();
    ?>
    
    <?php
        NavBar::begin([
            'brandLabel' => FALSE,
            'options' => ['class' => 'navbar navbar-inverse'],
            ]);
            echo Nav::widget([
                'items' => [
                    ['label' => 'Inicio', 'url' => ['/site/index']],
                    ['label' => '¿Dónde estamos?', 'url' => ['/site/estamos']],
                    ['label' => 'Conócenos', 'url' => ['/site/conocenos']],
                    ['label' => 'Contacto', 'url' => ['/site/contacto']],
                    ['label' => 'Operaciones matemáticas', 'url' => ['/site/operaciones']],
            ],
                'options' => ['class' => 'navbar-nav'],
            ]);
        NavBar::end();
    ?>

    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</div>


<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>


<!-- Cambiar siempre la vista de url en config/web.php - Descomentar línea 47 a 52 y cambiar a true
        
        'urlManager' => [
            'enablePrettyUrl' => true,
            'showScriptName' => true,
            'rules' => [
            ],
        ], -->

views/site/about.php
<?php

/* @var $this yii\web\View */

use yii\helpers\Html;

$this->title = 'About';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-about">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        This is the About page. You may modify the following file to customize its content:
    </p>

    <code><?= __FILE__ ?></code>
</div>

views/site/conocenos.php
<?php
/* @var $this yii\web\View */

use yii\helpers\Html;

$this->title = 'Conócenos';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-about">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::img('@web/imgs/Desarrollo de Aplicaciones con Tecnología Web.jpg', ['alt' => 'Curso Desarrollo 2018']) ?>
    </p>
    <div class="container">

        <div class="row">
            <div class="col-sm-4 col-md-3">
                <div class="thumbnail">
                    <img src="https://picsum.photos/200/100/?random=1" alt="...">
                    <div class="caption">
                        <h3>Foto 1</h3>
                        <p>Introduce un texto</p>
                        <p><a href="#" class="btn btn-primary" role="button">Button</a></p>
                    </div>
                </div>
                <div class="thumbnail">
                    <img src="https://picsum.photos/200/100/?random=2" alt="...">
                    <div class="caption">
                        <h3>Foto 2</h3>
                        <p>Introduce un texto</p>
                        <p><a href="#" class="btn btn-primary" role="button">Button</a></p>
                    </div>
                </div>
                <div class="thumbnail">
                    <img src="https://picsum.photos/200/100/?random=3" alt="...">
                    <div class="caption">
                        <h3>Foto 3</h3>
                        <p>Introduce un texto</p>
                        <p><a href="#" class="btn btn-default" role="button">Button</a></p>
                    </div>
                </div>
            </div>
        </div>
    </div>

</div>

views/site/contact.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model app\models\ContactForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;
use yii\captcha\Captcha;

$this->title = 'Contact';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-contact">
    <h1><?= Html::encode($this->title) ?></h1>

    <?php if (Yii::$app->session->hasFlash('contactFormSubmitted')): ?>

        <div class="alert alert-success">
            Thank you for contacting us. We will respond to you as soon as possible.
        </div>

        <p>
            Note that if you turn on the Yii debugger, you should be able
            to view the mail message on the mail panel of the debugger.
            <?php if (Yii::$app->mailer->useFileTransport): ?>
                Because the application is in development mode, the email is not sent but saved as
                a file under <code><?= Yii::getAlias(Yii::$app->mailer->fileTransportPath) ?></code>.
                Please configure the <code>useFileTransport</code> property of the <code>mail</code>
                application component to be false to enable email sending.
            <?php endif; ?>
        </p>

    <?php else: ?>

        <p>
            If you have business inquiries or other questions, please fill out the following form to contact us.
            Thank you.
        </p>

        <div class="row">
            <div class="col-lg-5">

                <?php $form = ActiveForm::begin(['id' => 'contact-form']); ?>

                    <?= $form->field($model, 'name')->textInput(['autofocus' => true]) ?>

                    <?= $form->field($model, 'email') ?>

                    <?= $form->field($model, 'subject') ?>

                    <?= $form->field($model, 'body')->textarea(['rows' => 6]) ?>

                    <?= $form->field($model, 'verifyCode')->widget(Captcha::className(), [
                        'template' => '<div class="row"><div class="col-lg-3">{image}</div><div class="col-lg-6">{input}</div></div>',
                    ]) ?>

                    <div class="form-group">
                        <?= Html::submitButton('Submit', ['class' => 'btn btn-primary', 'name' => 'contact-button']) ?>
                    </div>

                <?php ActiveForm::end(); ?>

            </div>
        </div>

    <?php endif; ?>
</div>

views/site/contacto.php
<?php
/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model app\models\ContactForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;
use yii\captcha\Captcha;

$this->title = 'Contacto';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-contact">
    <h1><?= $titulo ?></h1>

<?php
/*
  var_dump($this);

  echo "<pre>";
  yii\helpers\VarDumper::dump($this);
  echo "</pre>";
 */
?>

    <form method="get">
        <div class="form-group">
            <label for="nombre">Nombre Completo</label>
            <input type="text" class="form-control" name="nombre" id="nombre" placeholder="Escribe tu nombre">
        </div>
        <button type="submit" name="enviar" class="btn btn-default">Enviar</button>
    </form>


</div>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/estamos.php
<?php

/* @var $this yii\web\View */

use yii\helpers\Html;

$this->title = '¿Dónde estamos?';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-about">
    <h1><?= Html::encode($this->title) ?></h1>

    <iframe src="https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d2047.7432043351969!2d-3.813272187035792!3d43.461720126487066!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0xd494bcc568fd8c3%3A0x7858c552ade0effc!2sAlpe+Formacion!5e0!3m2!1ses!2ses!4v1536576271862" width="600" height="450" frameborder="0" style="border:0" allowfullscreen></iframe>

</div>

views/site/formulario.php
<div>

    <div>
        <label for="numero1">Número 01 </label>
        <input type="number" name="numeros[]" id="numero1" value="1">
    </div>
    
    <div>
        <label for="numero2">Número 02 </label>
        <input type="number" name="numeros[]" id="numero2" value="2">
    </div>
    
    <div>
        <label for="numero3">Número 03 </label>
        <input type="number" name="numeros[]" id="numero3" value="3">
    </div>
    
    <div>
        <label for="numero4">Número 04 </label>
        <input type="number" name="numeros[]" id="numero4" value="4">
    </div>
    
    <div>
        <label for="numero5">Número 05 </label>
        <input type="number" name="numeros[]" id="numero5" value="5">
    </div>
    
    <div>
        <label for="numero6">Número 06 </label>
        <input type="number" name="numeros[]" id="numero6" value="6">
    </div>
    
    <div>
        <label for="numero7">Número 07 </label>
        <input type="number" name="numeros[]" id="numero7" value="7">
    </div>
    
    <div>
        <label for="numero8">Número 08 </label>
        <input type="number" name="numeros[]" id="numero8" value="8">
    </div>
    
    <div>
        <label for="numero9">Número 09 </label>
        <input type="number" name="numeros[]" id="numero9" value="9">
    </div>
    
    <div>
        <label for="numero10">Número 10 </label>
        <input type="number" name="numeros[]" id="numero10" value="10">
    </div>
    
    <?php
        include "widgetBotones.php";
    ?>

</div>

views/site/index.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */

$this->title = 'Primer ejemplo de Yii 2';
?>
<div class="site-index">

    <div class="jumbotron">
        <h1>Página de Inicio!</h1>

        <p class="lead">Desarrollado por I. Garrote</p>
        

        <p><a class="btn btn-lg btn-success" href="https://www.yiiframework.com/doc/api/2.0">Api Yii2 Documentación</a></p>
    </div>

    <div class="body-content">

        <div class="row">
            <div class="col-lg-4">
                <h2>Manual Yii 2</h2>

                <p>Todas las clases de Yii 2</p>

                <p><a class="btn btn-default" href="https://www.yiiframework.com/doc/guide/2.0/es">Yii2 Guía &raquo;</a></p>
                <p><?= Html::a('Guía de Yii2', 'https://www.yiiframework.com/doc/guide/2.0/es', ['site/index'], ['class' => 'btn btn-default']) ?></p>
            </div>
            <div class="col-lg-4">
                <h2>Helper-HTML  Yii 2</h2>

                <p>Clases auxiliares: HTML Yii 2</p>

                <p><a class="btn btn-default" href="https://www.yiiframework.com/doc/guide/2.0/es/helper-html">Api Yii2 Documentación &raquo;</a></p>
            </div>
            <div class="col-lg-4">
                <h2>Bootstrap Yii 2</h2>

                <p>Documentación Api Bootstrap Yii 2</p>

                <p><a class="btn btn-default" href="https://www.yiiframework.com/extension/yiisoft/yii2-bootstrap/doc/api/2.1">Bootstrap Yii2 Documentación &raquo;</a></p>
                <p><?= Html::a('Guía de Yii2', 'https://www.yiiframework.com/extension/yiisoft/yii2-bootstrap/doc/api/2.1', ['site/index'], ['class' => 'btn btn-default']) ?></p>
            </div>
        </div>
        <div class="jumbotron">
            <h2>BOOTSTRAP 3</h2>

            <p class="lead">Componentes de Bootstrap</p>
        

            <p><a class="btn btn-lg btn-success" href="https://getbootstrap.com/docs/3.3/components/#navbar">Bootstrap</a></p>
        </div>

    </div>
</div>


<!-- Cambiar siempre la vista de url en config/web.php - Descomentar línea 47 a 52 y cambiar a true
        
        'urlManager' => [
            'enablePrettyUrl' => true,
            'showScriptName' => true,
            'rules' => [
            ],
        ], -->

views/site/login.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model app\models\LoginForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

$this->title = 'Login';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-login">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out the following fields to login:</p>

    <?php $form = ActiveForm::begin([
        'id' => 'login-form',
        'layout' => 'horizontal',
        'fieldConfig' => [
            'template' => "{label}\n<div class=\"col-lg-3\">{input}</div>\n<div class=\"col-lg-8\">{error}</div>",
            'labelOptions' => ['class' => 'col-lg-1 control-label'],
        ],
    ]); ?>

        <?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

        <?= $form->field($model, 'password')->passwordInput() ?>

        <?= $form->field($model, 'rememberMe')->checkbox([
            'template' => "<div class=\"col-lg-offset-1 col-lg-3\">{input} {label}</div>\n<div class=\"col-lg-8\">{error}</div>",
        ]) ?>

        <div class="form-group">
            <div class="col-lg-offset-1 col-lg-11">
                <?= Html::submitButton('Login', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>
            </div>
        </div>

    <?php ActiveForm::end(); ?>

    <div class="col-lg-offset-1" style="color:#999;">
        You may login with <strong>admin/admin</strong> or <strong>demo/demo</strong>.<br>
        To modify the username/password, please check out the code <code>app\models\User::$users</code>.
    </div>
</div>

views/site/opController.php
<?php

    function actionIndex(){
        return [
            "titulo" => "Operaciones matemáticas",
            "content" => "formulario.php",
            "pie" => "© 2018 CURSO DE DESARROLLO DE APLICACIONES CON TECNOLOGÍA WEB &nbsp; - &nbsp; I. Garrote",
        ];
    }
    
    function actionMedia() {
    $datos = $_REQUEST['numeros'];
    /*
      Comprobar si es array o string
     */
    if (gettype($datos) == "string") {
        $datos = explode(",", $datos);
        echo var_dump($datos);
    }
    $resultado = 0;
    foreach ($datos as $v) {
        $resultado += $v;
    }
    $resultado /= count($datos);
    /*
      Convertir los nº en un string
     */
    $datos = implode(",", $datos);
    echo var_dump($datos);
    return [
        'titulo' => "Operaciones matemáticas",
        'content' => 'resultado_op.php',
        'mensaje' => 'La media es: ',
        "pie" => "© 2018 CURSO DE DESARROLLO DE APLICACIONES CON TECNOLOGÍA WEB &nbsp; - &nbsp; I. Garrote",
        'numeros' => $datos,
        'resultado' => $resultado,
    ];
}

function actionModa() {
    $datos = $_REQUEST['numeros'];
    /*
      Comprobar si es array o string
     */
    if (gettype($datos) == "string") {
        $datos = explode(",", $datos);
        echo var_dump($datos);
    }
    $resultado = 0;
    foreach ($datos as $valor) {
        if ($valor < $resultado) {
            break;
        } else {
            $resultado = $valor;
        }
    }
    /*
      Convertir los nº en un string
     */
    $datos = implode(",", $datos);
    echo var_dump($datos);
    return [
        'titulo' => "Operaciones matemáticas",
        'content' => 'resultado_op.php',
        'mensaje' => 'La moda es: ',
        "pie" => "© 2018 CURSO DE DESARROLLO DE APLICACIONES CON TECNOLOGÍA WEB &nbsp; - &nbsp; I. Garrote",
        'numeros' => $datos,
        'resultado' => $resultado,
    ];
}

function actionMediana() {
    $datos = $_REQUEST['numeros'];
    /*
      Comprobar si es array o string
     */
    if (gettype($datos) == "string") {
        $datos = explode(",", $datos);
        echo var_dump($datos);
    }
    $resultado = 0;
    foreach ($datos as $v) {
        $resultado += $v;
    }
    $resultado /= count($datos);
    /*
      Convertir los nº en un string
     */
    $datos = implode(",", $datos);
    echo var_dump($datos);
    return [
        'titulo' => "Operaciones matemáticas",
        'content' => 'resultado_op.php',
        'mensaje' => 'La mediana es: ',
        "pie" => "© 2018 CURSO DE DESARROLLO DE APLICACIONES CON TECNOLOGÍA WEB &nbsp; - &nbsp; I. Garrote",
        'numeros' => $datos,
        'resultado' => $resultado,
    ];
}

function actionDesviacion() {
    $datos = $_REQUEST['numeros'];
    /*
      Comprobar si es array o string
     */
    if (gettype($datos) == "string") {
        $datos = explode(",", $datos);
        echo var_dump($datos);
    }
    /*$resultado = 0;
    $media = 0;
    foreach ($datos as $v) {
        $media += $v;
    }
    $media /= count($datos);*/
    
    $resultado = 0;
    for ($i = 0; $i < count($datos); $i++) {
        $resultado += $datos[$i];
    }
    $media = $resultado / count($datos);
    $sum2 = 0;
    for ($i = 0; $i < count($datos); $i++) {
        $sum2 += ($datos[$i] - $media) * ($datos[$i] - $media);
    }
    $vari = $sum2 / count($datos);
    $sq = sqrt($vari);
    /*
      Convertir los nº en un string
     */
    $datos = implode(",", $datos);
    echo var_dump($datos);
    return [
        'titulo' => "Operaciones matemáticas",
        'content' => 'resultado_op.php',
        'mensaje' => 'La desviación aritmética es: ',
        "pie" => "© 2018 CURSO DE DESARROLLO DE APLICACIONES CON TECNOLOGÍA WEB &nbsp; - &nbsp; I. Garrote",
        'numeros' => $datos,
        'resultado' => $resultado,
    ];
    }   
        
        
        if (isset($_REQUEST["boton"])) {
            switch ($_REQUEST['boton']) {
                case 'media':
                    $datos= actionMedia();
                    break;
                case 'moda':
                    $datos= actionModa();
                    break;
                case 'mediana':
                    $datos= actionMediana();
                    break;
                case 'desviacion':
                    $datos= actionDesviacion();
                    break;

                default:
                    $datos= actionIndex();
                    break;
            }
        }else{
            $datos= actionIndex();
        }
        
        if (isset($_REQUEST["view"])){
        $datos["content"]=$_REQUEST["view"] . ".php";
        }
    

views/site/operaciones.php
<?php
    require_once "opController.php";
    
    use yii\helpers\Html;

    $this->title = 'Operaciones matemáticas';
    $this->params['breadcrumbs'][] = $this->title;
    
?>

    <style>
        #wrapper{
            display: block;
            text-align: center;
            font-size: 1.5em;
        }
        div, label, imput, button, a{
            margin: 5px;
            text-decoration: none;
        }
        h3{
            color: red;
            margin: 20px 100px;
        }
    </style>

        <div class="site-about">
            <h1><?= Html::encode($this->title) ?></h1>
            <div>
                <h3><a href="operaciones.php">FORMULARIO</a></h3>
            </div>
            <form method="get">
                <?php
                include $datos["content"];
                ?>
            </form>

        </div>

views/site/resultado.php
<?php

    echo $longitud;

views/site/resultado_op.php
<div>
    <?php
        
        echo "<br>";
        echo "<h4>";
        echo $datos["mensaje"];
        echo $datos["resultado_op"];
        echo "</h4>";
        echo "<br>";
    ?>    
    <form method="get">
        <input type="text" name="numeros" value="<?= $datos["numeros"] ?>">
    <?php
        include "widgetBotones.php";
    ?>
    </form>
</div>



    

views/site/widgetBotones.php
<div>
    <h3>CALCULAR</h3>
</div>

<div>
    <button class="btn btn-danger" name="boton" value="media">Media</button>
    <button class="btn btn-danger" name="boton" value="moda">Moda</button>
    <button class="btn btn-danger" name="boton" value="mediana">Mediana</button>
    <button class="btn btn-danger" name="boton" value="desviacion">Desviación</button>
</div>